
require 'flow/version'
require 'flow/errors'
require 'flow/config'
require 'flow/connection'
require 'flow/models'
require 'flow/response'

module Flow

  def self.config
    Flow::Config.instance
  end

  def self.connection
    @__connection_cache ||= Flow::Connection.new(api_key, url)
  end

  ##################################################
  # Config helpers
  ##################################################
  def self.url
    config.url
  end

  def self.url=(url)
    config.url = url
  end

  def self.api_key
    config.api_key
  end

  def self.api_key=(api_key)
    config.api_key = api_key
  end

  ##################################################
  # Load helpers
  ##################################################
  def self.pool(pool_token)
    Flow::Models::Pool.load(connection, pool_token)
  end

  def self.card(card_token)
    Flow::Models::Card.load(connection, card_token)
  end

  def self.transaction(transaction_token)
    Flow::Models::Transaction.load(connection, transaction_token)
  end

end