module Flow
  module Models
    class Card < Model

      def ready?
        self.status == 'ready'
      end

      def supported?
        self.ready?
      end

      def unsupported?
        self.status == 'unsupported'
      end

      def credit!(amount, options={})
        r = connection.post("cards/#{self.token}/credits") do
          {
            amount: amount
          }
        end

        raise Flow::Errors::ResponseError.new(r.message) unless r.success?
        
        r.transaction
      end

    end
  end
end