module Flow
  module Models
    class Transaction < Model

      def self.build(connection, model_hash)
        case model_hash['type'].to_sym
        when :credit
          return Credit.new(connection, model_hash)
        else
          raise Flow::Errors::BuildError.new("Invalid Transaction type: #{model_hash['type']}.")
        end
      end

      # Override inherited behavior.
      # This causes subclasses of transactions to continue
      # to be treated as transactions at the API level.
      def self.__model_name
        'transaction'
      end

      def credit?
        self.type == 'credit'
      end

    end
  end
end